NX二次开发 UFUN创建扫掠 UF_MODL_create_sweep

NX二次开发 UFUN创建扫掠 UF_MODL_create_sweep

//VS8.0+VS2010
#include <uf_modl.h>
#include <uf_curve.h>
#include <uf_vec.h>

extern DllExport void ufsta(char* param, int* returnCode, int rlen)
{
	if (UF_initialize())
		return;


    //创建三点圆弧,引导线
    double first_point1[3] = { 0.0, 0.0, 0.0 };
    double second_point1[3] = { 0.0, 0.0, 5.0 };
    double third_point1[3] = { 8.0, 0.0, 2.0 };
    tag_t arc_tag1 = NULL_TAG;
    UF_CURVE_create_arc_thru_3pts(1, first_point1, second_point1, third_point1, &arc_tag1);

    //创建三点整圆,截面线
    double first_point2[3] = { -2.0, 0.0, 0.0 };
    double second_point2[3] = { 0.0, 2.0, 0.0 };
    double third_point2[3] = { 2.0, 0.0, 0.0 };
    tag_t arc_tag2 = NULL_TAG;
    UF_CURVE_create_arc_thru_3pts(2, first_point2, second_point2, third_point2, &arc_tag2);

    //定义引导线
    UF_STRING_t s_guide;
    UF_MODL_init_string_list(&s_guide);
    UF_MODL_create_string_list(1, 1, &s_guide);//第二个参数为引导线数量
    s_guide.num = 1;
    s_guide.string[0] = 1;//引导线数量
    s_guide.dir[0] = 1;
    s_guide.id[0] = arc_tag1; //将前面创建的螺旋线tag作为引导线

    //定义截面线
    UF_STRING_t    s_section;
    UF_MODL_init_string_list(&s_section);
    UF_MODL_create_string_list(1, 1, &s_section);//第二个参数为截面线数量
    s_section.num = 1;
    s_section.string[0] = 1;//截面线数量
    s_section.dir[0] = 1;
    s_section.id[0] = arc_tag2;//输入截面线tag

    //定义脊线
    UF_STRING_t s_spine;
    UF_MODL_init_string_list(&s_spine);

    //设置定位方法
    UF_METHOD_t orientation;
    orientation.method = 4;//定位方法(方向)4是固定
    orientation.value[0] = 0;
    orientation.value[1] = 1;
    orientation.value[2] = 0;
    orientation.id = 0;
    orientation.inter = 0;

    //设置缩放方法
    UF_METHOD_t scaling;
    scaling.method = 1;
    scaling.value[0] = 1;
    scaling.value[1] = 0;
    scaling.value[2] = 0;
    scaling.id = 0;
    scaling.inter = 0;

    int alignment = 1;//调整方法,参数还是弧长
    int inter = 1;//插值方法,线性还是立方
    int body_type = 1;//设置扫掠片体还是实体
    double tol[3] = { 0, 0, 0 };//指定公差(全为0就是勾选保留形状)
    tag_t body_tag = NULL_TAG;
    //创建扫掠
    UF_MODL_create_sweep(&s_guide, &s_section, &s_spine, &orientation, &scaling, &alignment, &inter, &body_type, UF_NULLSIGN, tol, &body_tag);

    //释放
    UF_MODL_free_string_list(&s_guide);
    UF_MODL_free_string_list(&s_section);
    UF_MODL_free_string_list(&s_spine);

	UF_terminate();
}

//梅雷QQ1821117007

在这里插入图片描述

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

梅雷

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值